	device pentagon1024 ; but code is for ATM Turbo 2+ ;)

	org #8000

begin
        jp START

; SHADOW : enable shadow ports and set Turbo2+ mode
; A - value to write into port FD77

SHADOW  LD BC,#FD77 ; enable shadow ports
        LD IX,10835
        PUSH IX
        JP #3D2F

; A - memory page number (0..63) for window #0000..#3FFF

;MEM0	XOR %01111111
;	LD BC,#3FF7
;	OUT (C),A
;       RET

; A - memory page number (0..63) for window #4000..#7FFF

MEM1	XOR %01111111
	LD BC,#7FF7
	OUT (C),A
	RET

; A - memory page number (0..63) for window #8000..#BFFF

;MEM2	XOR %01111111
;	LD BC,#BFF7
;	OUT (C),A
;       RET

; A - memory page number (0..63) for window #C000..#FFFF

MEM3	XOR %01111111
	LD BC,#FFF7
	OUT (C),A
        RET

RND
	push bc
	push hl
seed=$+1
	ld hl,0
	ld b,h,c,l
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld bc,12423
	add hl,bc
	ld (seed),hl
	ld a,h
	pop hl
	pop bc
	ret

START
	xor a
	out (#fe),a
	ld sp,#C000

        ld A,%10101010 ; turbo and 640x200
        call SHADOW

;	ld a,1
;	out (#fe),a

	ld a,1
	call MEM1
	ld a,5
	call MEM3

;	ld ix,#4000
;	ld iy,#C000
;	ld c,16
;	ld a,0
;loop	ld (ix),a
;	ld (iy),#FF
;	inc ix
;	inc iy
;	inc a
;	dec c
;	jr nz,loop

	ld de,#C001
	ld hl,#C000
	ld (hl),#00
	ld bc,#4000
	ldir

	ld de,#4001
	ld hl,#4000
	ld (hl),#02
	ld bc,#4000
	ldir

	ld hl,image
loop1	ld ix,#C014
	ld iy,#E013
	ld a,(curline)
	push hl
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld d,h
	ld e,l
	add hl,hl
	add hl,hl
	add hl,de
	ex de,hl
	add ix,de
	add iy,de
	pop hl	
loop2	ld de,#8000
	add ix,de
	add iy,de
	; now we work with attributes
     	ld a,(hl)
	and #C0
	cp #00
	jr z,lpix0
	cp #40
	jr z,lpix1
	cp #80
	jr z,lpix2
	; black on white (for eyes)
	ld a,#38
	jr lpixset
lpix2   ; white on yellow
        ld a,#37
	jr lpixset
lpix1   ; yellow on red
	ld a,#16
	jr lpixset
lpix0   ; red on black
        ld a,#02
lpixset ld (ix),a
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
	ld (ix),a
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
        ld de,#8000
	add ix,de
	add iy,de
	; now we work with pixels
        ld a,(hl)
	and #30
	cp #30
	jp z,lpix13
	cp #20
	jp z,lpix12
	cp #10
	jp z,lpix11
        ld a,(ix)
	and %00111111
	ld (ix),a
	ld a,(iy)
	and %11111100
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	and %00111111
	ld (ix),a
	ld a,(iy)
	and %11111100
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
	jp lpixset2
lpix11  ld a,(ix)
	and %00111111
	ld (ix),a
	ld a,(iy)
	and %11111100
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	and %00111111
	or  %01000000
	ld (ix),a
	ld a,(iy)
	and %11111100
	or  %00000001
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
	jp lpixset2
lpix12  ld a,(ix)
	and %00111111
	or  %10000000
	ld (ix),a
	ld a,(iy)
	and %11111100
	or  %00000010
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	and %00111111
	or  %01000000
	ld (ix),a
	ld a,(iy)
	and %11111100
	or  %00000001
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
	jp lpixset2
lpix13  ld a,(ix)
	and %00111111
	or  %10000000
	ld (ix),a
	ld a,(iy)
	and %11111100
	or  %00000010
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	or  %11000000
	ld (ix),a
	ld a,(iy)
	or  %00000011
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
lpixset2
        ld a,(hl)
	and #03
	cp #03
	jp z,lpix23
	cp #02
	jp z,lpix22
	cp #01
	jp z,lpix21
        ld a,(ix)
	and %11001111
	ld (ix),a
	ld a,(iy)
	and %11110011
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	and %11001111
	ld (ix),a
	ld a,(iy)
	and %11110011
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
	jp lpixset3
lpix21  ld a,(ix)
	and %11001111
	ld (ix),a
	ld a,(iy)
	and %11110011
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	and %11001111
	or  %00010000
	ld (ix),a
	ld a,(iy)
	and %11110011
	or  %00000100
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
	jp lpixset3
lpix22  ld a,(ix)
	and %11001111
	or  %00100000
	ld (ix),a
	ld a,(iy)
	and %11110011
	or  %00001000
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	and %11001111
	or  %00010000
	ld (ix),a
	ld a,(iy)
	and %11110011
	or  %00000100
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
	jp lpixset3
lpix23  ld a,(ix)
	and %11001111
	or  %00100000
	ld (ix),a
	ld a,(iy)
	and %11110011
	or  %00001000
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	or  %00110000
	ld (ix),a
	ld a,(iy)
	or  %00001100
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
lpixset3
	inc hl
        ld a,(curbyte)
	inc a
	ld (curbyte),a
	ld d,a
	ld a,(maxbyte)
	cp d
	jp z,lendline
        ld a,(hl)
	and #30
	cp #30
	jp z,lpix33
	cp #20
	jp z,lpix32
	cp #10
	jp z,lpix31
        ld a,(ix)
	and %11110011
	ld (ix),a
	ld a,(iy)
	and %11001111
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	and %11110011
	ld (ix),a
	ld a,(iy)
	and %11001111
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
	jp lpixset4
lpix31  ld a,(ix)
	and %11110011
	ld (ix),a
	ld a,(iy)
	and %11001111
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	and %11110011
	or  %00000100
	ld (ix),a
	ld a,(iy)
	and %11001111
	or  %00010000
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
	jp lpixset4
lpix32  ld a,(ix)
	and %11110011
	or  %00001000
	ld (ix),a
	ld a,(iy)
	and %11001111
	or  %00100000
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	and %11110011
	or  %00000100
	ld (ix),a
	ld a,(iy)
	and %11001111
	or  %00010000
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
	jp lpixset4
lpix33  ld a,(ix)
	and %11110011
	or  %00001000
	ld (ix),a
	ld a,(iy)
	and %11001111
	or  %00100000
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	or  %00001100
	ld (ix),a
	ld a,(iy)
	or  %00110000
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
lpixset4
        ld a,(hl)
	and #03
	cp #03
	jp z,lpix43
	cp #02
	jp z,lpix42
	cp #01
	jp z,lpix41
        ld a,(ix)
	and %11111100
	ld (ix),a
	ld a,(iy)
	and %00111111
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	and %11111100
	ld (ix),a
	ld a,(iy)
	and %00111111
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
	jp lpixset0
lpix41  ld a,(ix)
	and %11111100
	ld (ix),a
	ld a,(iy)
	and %00111111
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	and %11111100
	or  %00000001
	ld (ix),a
	ld a,(iy)
	and %00111111
	or  %01000000
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
	jp lpixset0
lpix42  ld a,(ix)
	and %11111100
	or  %00000010
	ld (ix),a
	ld a,(iy)
	and %00111111
	or  %10000000
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	and %11111100
	or  %00000001
	ld (ix),a
	ld a,(iy)
	and %00111111
	or  %01000000
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
	jp lpixset0
lpix43  ld a,(ix)
	and %11111100
	or  %00000010
	ld (ix),a
	ld a,(iy)
	and %00111111
	or  %10000000
	ld (iy),a
	ld de,#0028
	add ix,de
	add iy,de
        ld a,(ix)
	or  %00000011
	ld (ix),a
	ld a,(iy)
	or  %11000000
	ld (iy),a
	ld de,#FFD8
	add ix,de
	add iy,de
lpixset0
        inc hl
        ld a,(curbyte)
	inc a
	ld (curbyte),a
	ld d,a
	ld a,(maxbyte)
	cp d
	jp z,lendline

	push ix
	pop de
	bit 5,d
	jp nz,lincr
	set 5,d
	push de
	pop ix
	push iy
	pop de
	res 5,d
	push de
	pop iy
	jp loop2
lincr	res 5,d
	push de
	pop ix
	push iy
	pop de
	set 5,d
	push de
	pop iy
	inc ix
	dec iy
	jp loop2

lendline
	xor a
	ld (curbyte),a
	ld a,(curline)
	inc a
	ld (curline),a
	ld a,(hl)
	cp #FF
	jp nz,loop1

	ld ix,#CDAF
	ld iy,#EDAF
	call eyesub
	ld ix,#CDA8
	ld iy,#EDA8
	call eyesub

	jr $-1

eye 	dw #0FF0
	dw #33CC
	dw #FFFF
	dw #CFF3
	dw #FFFF
	dw #33CC
	dw #0FF0	

eyesub
	ld a,7
	ld hl,eye
	ld de,#0028
eyeloop
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld (ix),b
	ld (iy),c
	add ix,de
	add iy,de	
	dec a
	jr nz,eyeloop
	ret

curline db 0
curbyte db 0
maxbyte db 35

image

        incbin "KrazyShaos1b.bin"

	db #FF

end

	display "Size ",/d,end-begin," bytes"
	
	savebin "code.c",begin,end-begin
	
	LABELSLIST "user.l"
